# HomologousPointsExtraction

## Brief Description

Allows computing homologous points between images using keypoints

## Tags

Feature Extraction

## Long Description

This application allows computing homologous points between images using keypoints. SIFT or SURF keypoints can be used and the band on which keypoints are computed can be set independently for both images. The application offers two modes : the first is the full mode where keypoints are extracted from the full extent of both images (please note that in this mode large image file are not supported). The second mode, called geobins, allows setting-up spatial binning to get fewer points spread accross the entire image. In this mode, the corresponding spatial bin in the second image is estimated using geographical transform or sensor modelling, and is padded according to the user defined precision. Last, in both modes the application can filter matches whose colocalisation in first image exceed this precision. The elevation parameters are to deal more precisely with sensor modelling in case of sensor geometry data. The outvector option allows creating a vector file with segments corresponding to the localisation error between the matches. It can be useful to assess the precision of a registration for instance. The vector file is always reprojected to EPSG:4326 to allow display in a GIS. This is done via reprojection or by applying the image sensor models.

## Parameters

- [param] -in1 <string> First input image. Mandatory: True. Default Value: ""
- [param] -band1 <int32> Index of the band from input image 1 to use for keypoints extraction. Mandatory: True. Default Value: "1"
- [param] -in2 <string> Second input image. Mandatory: True. Default Value: ""
- [param] -band2 <int32> Index of the band from input image 1 to use for keypoints extraction. Mandatory: True. Default Value: "1"
- [param] -threshold <float> The distance threshold for matching.. Mandatory: True. Default Value: "0.6"
- [param] -backmatching <boolean> If set to true, matches should be consistent in both ways.. Mandatory: False. Default Value: "True"
- [param] -precision <float> Estimated precision of the colocalisation function in pixels. Mandatory: True. Default Value: "0"
- [param] -mfilter <boolean> If enabled, this option allows filtering matches according to colocalisation from sensor or geographical information, using the given tolerancy expressed in pixels. Mandatory: False. Default Value: "True"
- [param] -2wgs84 <boolean> . Mandatory: False. Default Value: "True"
- [param] -elev <string> This group of parameters allows managing elevation values. Supported formats are SRTM, DTED or any geotiff. DownloadSRTMTiles application could be a useful tool to list/download tiles related to a product.. Mandatory: True. Default Value: "0"
- [param] -out <string> File containing the list of tie points. Mandatory: True. Default Value: ""
- [param] -outvector <string> File containing segments representing matches . Mandatory: False. Default Value: ""
- [param] -inxml <string> Load otb application from xml file. Mandatory: False. Default Value: ""
- [param] -outxml <string> Save otb application to xml file. Mandatory: False. Default Value: ""
[choice] -algorithm Choice of the detection algorithm to use surf,sift. Mandatory: True. Default Value: "surf"

- [group] -surf

- [group] -sift

[choice] -mode full,geobins. Mandatory: True. Default Value: "full"

- [group] -full

- [group] -geobins

- [param] -mode.geobins.binsize <int32> Radius of the spatial bin in pixels. Mandatory: True. Default Value: "256"
- [param] -mode.geobins.binsizey <int32> Radius of the spatial bin in pixels (y direction). If not set, the mode.geobins.binsize value is used.. Mandatory: False. Default Value: "0"
- [param] -mode.geobins.binstep <int32> Steps between bins in pixels. Mandatory: True. Default Value: "256"
- [param] -mode.geobins.binstepy <int32> Steps between bins in pixels (y direction). If not set, the mode.geobins.binstep value is used.. Mandatory: False. Default Value: "0"
- [param] -mode.geobins.margin <int32> Margin from image border to start/end bins (in pixels). Mandatory: True. Default Value: "10"

## Limitations

Full mode does not handle large images.

## Authors

OTB-Team

## See Also

RefineSensorModel

## Example of use

- in1: sensor_stereo_left.tif

- in2: sensor_stereo_right.tif

- mode: full

- out: homologous.txt